import DestinationBean;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AddDesRec extends JFrame 
{
	// For writing to file
	private ObjectOutputStream output;

	// User interface components
	private JPanel topPanel;	
	private JLabel labels[];
	private JTextField fields[];
	private JButton saveButton;
	
	// Items that needs input
	private int size = 5;
	private String names[] = 
	{"Purpose", "Destination Name", "Destination Type", "Related Info (URL)", "Likelihood(1-10)"};
	
	// Constructor
	public AddDesRec()
	{
		super("Add a new destination record");
		
		// Initialize the graphical components
		Container c = getContentPane();
		topPanel = new JPanel(new GridLayout(size, 2));
		labels = new JLabel[size];
		fields = new JTextField[size];
		for (int i = 0; i < labels.length; i++)
			labels[i] = new JLabel(names[i]);
		for (int i = 0; i < fields.length; i++)
			fields[i] = new JTextField("");
		for (int i = 0; i < size; i++)
		{
			topPanel.add(labels[i]);
			topPanel.add(fields[i]);
		}
		c.add(topPanel, BorderLayout.CENTER);
		
		saveButton = new JButton("Save");
		saveButton.setEnabled(true);
		saveButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				for (int i = 0; i < size; i++)
				{
					if ((labels[i].getText().equals("Destination Name") || labels[i].getText().equals("Related Info (URL)")) && fields[i].getText().equals(""))
					{
						JOptionPane.showMessageDialog(null, "Please fill out the fields!", "Error", JOptionPane.ERROR_MESSAGE);
						return;
					}
				}	
				addRecord();
			}
		}
		);
		c.add(saveButton, BorderLayout.SOUTH);
		
		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{				
				if (output!= null)
					clearFields();
				hide();
			}
		}
		);
				
		setSize(300, 200);
		show();
	}
	
	// Clear the user input
	public void clearFields()
	{
		for (int i = 0; i < size; i++)
			fields[i].setText("");	
	}
	
	// Add the destination information that user has entered to a sequential-access file
	public void addRecord()
	{
		try
		{
			if (output == null)
			{
				output = new ObjectOutputStream(new FileOutputStream("destination_rec.dat"));
			}		
			DestinationBean des = new DestinationBean(fields[0].getText(), fields[1].getText(), fields[2].getText(), fields[3].getText(), Integer.parseInt(fields[4].getText()));
			output.writeObject(des);
			output.flush();
			clearFields();
		}catch (IOException e)
		{
			JOptionPane.showMessageDialog(this, "Error accessing record file", "Error", JOptionPane.ERROR_MESSAGE);
			closeFile();
		}
	}
	
	// Close the output to file
	public void closeFile()
	{
		try
		{
			if (output != null)
				output.close();
		}catch(IOException io)
		{
			JOptionPane.showMessageDialog(this, "Error closing record file", "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
}
	
	
		
			
		