import java.io.Serializable;

public class DestinationBean implements Serializable
{	
	private String purpose; // The purpose of the trip
	private String destinationName; // The name of the destination
	private String destinationType; // The type of the destination, e.g. airport, mall, train station
	private String relatedInfo; // The additional information related to the destination and the purpose of the trip, in the form of URLs
	private int likelihood; // The likelihood of havig the correct related information, if purpose is not given, scale 1 - 10
	
	// Constructors
	public DestinationBean()
	{
		purpose = destinationName = destinationType = relatedInfo = "";
		likelihood = 0;
	}
	
	public DestinationBean(String s1, String s2, String s3, String s4, int d)
	{
		purpose = s1;
		destinationName = s2;
		destinationType = s3;
		relatedInfo = s4;
		likelihood = d;
	}
	
	// Set and get the internal variables of the bean 
	public void setPurpose(String s)
	{
		purpose = s;
	}
	
	public String getPurpose()
	{
		return this.purpose;
	}
	
	public void setDestinationName(String s)
	{
		destinationName = s;
	}
	
	public String getDestinationName()
	{
		return this.destinationName;
	}
	
	public void setDestinationType(String s)
	{
		destinationType = s;
	}
	
	public String getDestinationType()
	{
		return this.destinationType;
	}
	
	public void setRelatedInfo(String s)
	{
		relatedInfo = s;
	}
	
	public String getRelatedInfo()
	{
		return this.relatedInfo;
	}
	
	public void setLikelihood(int d)
	{
		likelihood = d;
	}
	
	public int getLikelihood()
	{
		return this.likelihood;
	}
	
	// Future work:
	// calculate and update the likelihood ratio from users' entries
	// e.g. If user inputs many destination beans with the same destination but different purposes, 
	// and those beans have high likelihood ratios, then the likelihood ratio of this bean should be decreased
	// to adjust to users' desires
	public void updateLikelihood()
	{
	}
}