import DestinationBean;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ViewDesRec extends JFrame 
{
	// For reading from file
	private ObjectInputStream input;
	
	// User interface components
	private JPanel topPanel;
	private JLabel labels[];
	private JTextField fields[];
	private JButton nextButton;
	
	// Items that are displayed
	private int size = 5;
	private String names[] = 
	{"Purpose", "Destination Name", "Destination Type", "Related Info (URL)", "Likelihood(1-10)"
	};
	
	// Constructor
	public ViewDesRec()
	{
		super("View the destination records in order");
		
		// Initialize the graphical components
		Container c = getContentPane();
		topPanel = new JPanel(new GridLayout(size, 2));
		labels = new JLabel[size];
		fields = new JTextField[size];		
		for (int i = 0; i < labels.length; i++)
			labels[i] = new JLabel(names[i]);
		for (int i = 0; i < fields.length; i++)
			fields[i] = new JTextField("click next");		
		for (int i = 0; i < size; i++)
		{
			topPanel.add(labels[i]);
			topPanel.add(fields[i]);
		}
		c.add(topPanel, BorderLayout.CENTER);
		
		nextButton = new JButton("Next");
		nextButton.setEnabled(true);
		nextButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				viewRecord();
			}
		}
		);
		c.add(nextButton, BorderLayout.SOUTH);
		
		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				
				if (input!= null)
				{ 
					closeFile();
					clearFields();
				}
				hide();
			}
		}
		);
				
		setSize(300, 200);
		show();
	}
	
	// Clear the displayed fields
	public void clearFields()
	{
		for (int i = 0; i < size; i++)
			fields[i].setText("");	
	}
	
	// Display the destination information from file
	public void viewRecord()
	{
		try
		{
			if (input == null)
			{
				input = new ObjectInputStream(new FileInputStream("destination_rec.dat"));
			}		
			DestinationBean des = (DestinationBean)input.readObject();
			fields[0].setText(des.getPurpose());
			fields[1].setText(des.getDestinationName());
			fields[2].setText(des.getDestinationType());
			fields[3].setText(des.getRelatedInfo());
			fields[4].setText(String.valueOf(des.getLikelihood())); 			
		}catch(EOFException eof)
		{
			JOptionPane.showMessageDialog(this, "No more records in file", "End of File", JOptionPane.ERROR_MESSAGE);
		}catch(ClassNotFoundException cnf)
		{
			JOptionPane.showMessageDialog(this, "Unable to create object", "Class Not Found", JOptionPane.ERROR_MESSAGE);
		}catch(IOException io)
		{
			JOptionPane.showMessageDialog(this, "Error reading record file", "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	// Close the input from file
	public void closeFile()
	{
		try
		{
			if (input != null)
				input.close();
		}catch(IOException io)
		{
			JOptionPane.showMessageDialog(this, "Error closing record file", "Error", JOptionPane.ERROR_MESSAGE);
		}
	}
}
	
	
		
			
		